/***************************************************************************
                          komportcellarray.h  -  Komport Serial Port Communicator
                             -------------------
    begin                : Mon Feb 17 2003
    copyright            : (C) 2003 by Mike Sharkey
    email                : michael@sharkey.servebeer.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KOMPORTCELLARRAY_H
#define KOMPORTCELLARRAY_H

#include <qobject.h>
#include <qptrlist.h>
#include <qstring.h>
#include <qpoint.h>

#include "komportcell.h"

/**Encapsulates the array of character cells.
  *@author Mike Sharkey
  */

class KomportCellArray : public QObject  {
public:
  KomportCellArray();
	~KomportCellArray();

  /** initialize default settings */
  virtual void initSettings();
  /** emited when the cursor changes position */
  virtual void cursorChanged(QPoint _old, QPoint _new);
  /** a cell's content has changed */
 virtual  void cellChanged(QPoint _p);
  /** signal a row has changed */
  virtual void rowChanged(int _row);
  /** notify anyone who cares that the array has scrolled up by one row */
  virtual void scrolledUp();
  /** prepare for scrolling */
  virtual void aboutToScrollUp();
};

#endif
